-- create new recurringinvoice and recurringinvoiceitem tables
CREATE TABLE recurringinvoice (
	recurringinvoiceid BIGINT GENERATED BY DEFAULT AS IDENTITY(START WITH 1) NOT NULL,
	uuid VARCHAR(36) NOT NULL,
	created TIMESTAMP NOT NULL,
	updated TIMESTAMP,
	clientid BIGINT,
	name VARCHAR(30) NOT NULL,
    recurrencefrequency INTEGER NOT NULL,
    recurrenceinterval INTEGER NOT NULL,
    recurrencedayofweek INTEGER,
    recurrencedayofmonth INTEGER,
    recurrencestartdate DATE NOT NULL,
    recurrenceenddate DATE,
    recurrencecount INTEGER,
    duedays INTEGER NOT NULL,
    currency VARCHAR(255),
    projectbillingenabled BOOLEAN NOT NULL,
	PRIMARY KEY(recurringinvoiceid),
	CONSTRAINT fk_recurringinvoice_clientid FOREIGN KEY (clientid) REFERENCES client(clientid)
);

CREATE TABLE recurringinvoiceitem (
	recurringinvoiceitemid BIGINT GENERATED BY DEFAULT AS IDENTITY(START WITH 1) NOT NULL,
	uuid VARCHAR(36) NOT NULL,
	created TIMESTAMP NOT NULL,
	updated TIMESTAMP,
    name VARCHAR(15) NOT NULL,
    catalogitemid BIGINT,
    description VARCHAR(50),
    taxgroupenabled BOOLEAN NOT NULL,
    taxgroupid BIGINT,
    units NUMERIC,
    unitsdiscountenabled BOOLEAN NOT NULL,
    unitsdiscounttype INTEGER,
    unitsdiscountpercentagevalue NUMERIC,
    unitsdiscountfixedvalue NUMERIC,
    unitofmeasure VARCHAR(50),
    pricediscountenabled BOOLEAN NOT NULL,
    pricediscounttype INTEGER,
    pricediscountpercentagevalue NUMERIC,
    pricediscountrate NUMERIC,
    pricediscountcurrency VARCHAR(255),
    priceamount NUMERIC,
    pricecurrency VARCHAR(255),
    recurringinvoiceid BIGINT,
	PRIMARY KEY(recurringinvoiceitemid),
    CONSTRAINT fk_recurringinvoiceitem_catalogitemid FOREIGN KEY(catalogitemid) REFERENCES catalogitem(catalogitemid),
    CONSTRAINT fk_recurringinvoiceitem_taxgroupid FOREIGN KEY(taxgroupid) REFERENCES taxgroup(taxgroupid),
    CONSTRAINT fk_recurringinvoiceitem_recurringinvoiceid FOREIGN KEY(recurringinvoiceid) REFERENCES recurringinvoice(recurringinvoiceid)
);

ALTER TABLE invoice ADD recurringinvoiceid BIGINT;
ALTER TABLE invoice ADD CONSTRAINT fk_invoice_recurringinvoiceid FOREIGN KEY(recurringinvoiceid) REFERENCES recurringinvoice(recurringinvoiceid);

-- recurring invoices are disabled by default
ALTER TABLE business ADD recurringinvoicesenabled BOOLEAN;
UPDATE business SET recurringinvoicesenabled=FALSE;
ALTER TABLE business ALTER COLUMN recurringinvoicesenabled SET NOT NULL;